from os.path import isdir
from os.path import isfile
from os.path import join
from sys import platform


'''
  DIGENERATOR sample preparation utility v1.0
  by Aubery "Astro" Lis / SYTNHFOX

  If you found it somewhere else other than synthfoxmodular.com - 
  go to synthfoxmodular.com/module/eurorack/digenerator/firmware/
  for an official download.
  
  Don't reuse any of this code for a device that you're going to sell or stuff!
  
  Credit SYNTHFOX if you reuse it

  Creative Commons
  Attribution-NonCommercial-ShareAlike 4.0 International (CC BY-NC-SA 4.0) 

'''

def main():
  files = list()
  fileQty = 8
  prompt = "#:"
  directory = ""

  import prepareSound

  # intro
  print("\n\n\n--- DIGENERATOR SAMPLE CONVERSION V1.0 ---")
  print("\nThis utility will create a text file 'data.txt' with a piece of code that you can ",
  	"paste to the designated place in [Aubery's Drumkit] and [20KB Sampler] DIGENERATOR firmwares ",
  	"and put your custom samples in the module. Please, read the script messages carefully!",
  	"\n\nhit enter to continue...")
  input()


  # yes i am a bad person
  while (1):
    print("\n--- SELECT FILE REGISTRATION METHOD")
    print("\nYou can point this utility to a directory, or input 8 files manually, file by file.", 
      "if you choose directory, data.txt will be placed in the directory you provide. If you ",
      "choose file-by-file, data.txt will be placed in the folder this script is running from."
      "\n\ntype D for directory, and F for file by file, and hit enter")
    method = input(prompt)
    method = method.upper()[0]
    if not (method == "F" or method == "D"):
      print("\n[!] invalid option!")
      continue
    else:
      if (method == "D"):
        print("\n--- DIRECTORY-WIDE SCAN")
        print("\nThe directory should contain files 01.wav, 02.wav ... ... 08.wav - eight short wavefiles.",
          "\n\nProvide the full path to directory and hit enter:")
        # get directory
        directory = input(prompt).strip()
        #
        directory = prepareSound.preparePathString(directory)
        if (isdir(directory)):
          files = list()
          for x in range(8):
            checkName = join(directory, "0"+str(x+1)+".wav")
            if isfile(checkName):
              files.append(prepareSound.prepareWavPath(checkName))
            else:
              print("\n[!] file not found: " + checkName + "\n[!]make sure all the files are present!")
              continue
          break

          #files.append(prepareSound.prepareWavPath(file))
      elif (method == "F"):

        # get samples' paths
        print("\n--- DIRECTORY-WIDE SCAN")
        print("\nDrag-and-drop or write out each .wav file name and hit enter, file by file.")
        for x in range(fileQty):
          print("file " + str(x+1) + ":")
          file = input(prompt).strip()
          files.append(prepareSound.prepareWavPath(file))
        break


  # set the output directory
  if (directory == ""):
    outDir = "./"
  else:
    outDir = directory

  # write file
  print("\n\nworking...")
  prepareSound.process(files, outDir)
  print("done!")

if (__name__ == "__main__"):
  main()